/*
    TCFbECustomTableEx.h    December 4, 2004.

    Copyright (C) 2003-2005 CFbE Research Group,
    Software Engineering Laboratory,
    Graduate School of Information Science,
    Nara Institute of Science and Technology,
    All rights reserved.

    This program is free software; you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2, (at your option) or
    any later version.

    This program is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with GNU Emacs; see the file COPYING.  If not, write to the
    Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/
//---------------------------------------------------------------------------
#ifndef TCFbECustomTableExH
#define TCFbECustomTableExH
//---------------------------------------------------------------------------
// #include "Maprof.h"

#include <SysUtils.hpp>
#include "TCFbECell.h"
#include "TCFbEToolkit.h"
#include "TCFbERowColumnCachedTable.h"
#include "TCFbEColumnCachedTable.h"
#include "TCFbERowCachedTable.h"
#include "TCFbERowRowCachedTable.h"
//---------------------------------------------------------------------------
// 統計機能付きキャッシャブルテーブル
class TCFbECustomTableEx : public TCFbERowColumnCachedTable
{
public:
    virtual __fastcall TCFbECustomTableEx(void);    // コンストラクタ（空キャッシュを作成
    virtual __fastcall TCFbECustomTableEx(TStringList* RowLabelList, TStringList* ColumnLabelList);    // 指定された行列を備えた空テーブルを作成
    virtual __fastcall TCFbECustomTableEx(TStringList* SourceCsvStringList);   // コンストラクタ
    __fastcall ~TCFbECustomTableEx();    // デストラクタ

    virtual double __fastcall Normalize(double SourceValue, double MaxValue, double MinValue);  // Normalize する
    virtual void __fastcall PartialNormalize(TCFbECustomTableEx* DestTable, int ColumnIndex);   // Table の要素を部分的に Normalize する
    virtual void __fastcall Normalize(TCFbECustomTableEx* DestTable);                           // Table の要素を Normalize する
    virtual double __fastcall DisNormalize(double NormalizedValue, double MaxValue, double MinValue);   // ColumnIndex 列目の Normalize された値 NormalizedValue を DisNormalize して返す

    virtual double __fastcall Standardize(double SourceValue, double AverageValue, double StdevValue);  // Standardize する
    virtual void __fastcall PartialStandardize(TCFbECustomTableEx* DestTable, int ColumnIndex); // Table の要素を部分的に Standardize する
    virtual void __fastcall Standardize(TCFbECustomTableEx* DestTable);                         // Table の要素を Standardize する
    virtual double __fastcall DisStandardize(double StandardizedValue, double AverageValue, double StdevValue); // ColumnIndex 列目の Standardize された値 StandardizedValue を DisStandardize して返す

    virtual void __fastcall Ordering(TList* SortedCellList);                                    // Ordering する
    virtual void __fastcall PartialOrdering(TCFbECustomTableEx* DestTable, int ColumnIndex);    // Table の要素を部分的に Ordering する
    virtual void __fastcall Ordering(TCFbECustomTableEx* DestTable);                            // Table の要素を Ordering する
    virtual double __fastcall DisOrdering(double Order, TDoubleDynArray& SortedOrders, TDoubleDynArray& SortedValues);  // ColumnIndex 列目の Ordering された値 Order を DisOrdering して返す

    virtual double  __fastcall GetICFCoefficient(int j);    // j 列目の Inverse Case Frequency Coefficient を得る

    virtual double __fastcall GetMaxOfRow(int i);       // 行の最大値を返す．
    virtual double __fastcall GetMinOfRow(int i);       // 行の最小値を返す．
    virtual double __fastcall GetAverageOfRow(int i);   // 行の平均値を返す．
    virtual double __fastcall GetMedianOfRow(int i);    // 行の中間値を返す．
    virtual double __fastcall GetStdevOfRow(int i);     // 行の標準偏差を返す．
    virtual double __fastcall GetAveragedMultiplierOfRow(int BaseRowIndex, int ComparedRowIndex);   // ComparedRowIndex 番目の行の BaseRowIndex 番目の行に対する Averaged Multiplier を返す．
    virtual double __fastcall GetMedianOfMultiplierOfRow(int BaseRowIndex, int ComparedRowIndex);   // ComparedRowIndex 番目の行の BaseRowIndex 番目の行に対する Median of Multiplier を返す．

    virtual double __fastcall GetMaxOfColumn(int j);        // 列の最大値を返す．
    virtual double __fastcall GetMinOfColumn(int j);        // 列の最小値を返す．
    virtual double __fastcall GetAverageOfColumn(int j);    // 列の平均値を返す．
    virtual double __fastcall GetMedianOfColumn(int j);     // 列の中間値を返す．
    virtual double __fastcall GetStdevOfColumn(int j);      // 列の標準偏差を返す．
    virtual double __fastcall GetAveragedMultiplierOfColumn(int BaseColumnIndex, int ComparedColumnIndex);  // ComparedColumnIndex 番目の列の BaseColumnIndex 番目の列に対する Averaged Multiplier を返す．
    virtual double __fastcall GetMedianOfMultiplierOfColumn(int BaseColumnIndex, int ComparedColumnIndex);  // ComparedColumnIndex 番目の列の BaseColumnIndex 番目の列に対する Median of Multiplier を返す．

    // ChildCache を ChildCacheName という名前のキャッシュとして追加する
    virtual void __fastcall AddChildCache(TCFbECachedTable* ChildCache, const char* ChildCacheName, bool IsLinkedToParent);

    // ChildCacheName という名前のキャッシュを削除する
    virtual void __fastcall DeleteChildCache(const char* ChildCacheName);

protected:
    virtual TCFbECachedTable* __fastcall CreateClone(void) = 0;         // 自分自身のクローンを作成する
    virtual TCFbECachedTable* __fastcall CreateRotatedClone(void) = 0;  // 自分自身の行と列が入れ替わったクローンを作成する

    TCFbERowCachedTable*    MaxRowCache;
    TCFbERowCachedTable*    MinRowCache;
    TCFbERowCachedTable*    AverageRowCache;
    TCFbERowCachedTable*    MedianRowCache;
    TCFbERowCachedTable*    StdevRowCache;
    TCFbEColumnCachedTable* MaxColumnCache;
    TCFbEColumnCachedTable* MinColumnCache;
    TCFbEColumnCachedTable* AverageColumnCache;
    TCFbEColumnCachedTable* MedianColumnCache;
    TCFbEColumnCachedTable* StdevColumnCache;

private:

};
//---------------------------------------------------------------------------
#endif
